<?xml version="1.0" encoding="UTF-8"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified" targetNamespace="http://textgrid.info/namespaces/middleware/workflow/tgwf/2011/01" xmlns:tgwf="http://textgrid.info/namespaces/middleware/workflow/tgwf/2011/01">
  <xs:element name="tgwf">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="tgwf:description"/>
        <xs:element ref="tgwf:activities"/>
        <xs:element ref="tgwf:datalinks"/>
        <xs:element ref="tgwf:CRUD"/>
        <xs:element ref="tgwf:inputs"/>
        <xs:element ref="tgwf:metadatatransformation"/>
        <xs:element ref="tgwf:configparameters"/>
      </xs:sequence>
    </xs:complexType>
  </xs:element>
  <xs:element name="description" type="xs:string"/>
  <xs:element name="activities">
    <xs:complexType>
      <xs:sequence>
        <xs:element maxOccurs="unbounded" minOccurs="0" ref="tgwf:service"/>
      </xs:sequence>
    </xs:complexType>
  </xs:element>
  <xs:element name="service">
    <xs:complexType>
      <xs:attribute name="URI" use="required" type="xs:anyURI"/>
      <xs:attribute name="id" use="required" type="xs:integer"/>
    </xs:complexType>
  </xs:element>
  <xs:element name="datalinks">
    <xs:complexType>
      <xs:sequence>
        <xs:element maxOccurs="unbounded" ref="tgwf:link"/>
      </xs:sequence>
    </xs:complexType>
  </xs:element>
  <xs:element name="link">
    <xs:complexType>
      <xs:attribute name="fromParam" use="required" type="xs:NMTOKEN"/>
      <xs:attribute name="fromServiceID" use="required" type="xs:NMTOKEN"/>
      <xs:attribute name="id" use="required" type="xs:NMTOKEN"/>
      <xs:attribute name="toParam" use="required" type="xs:NMTOKEN"/>
      <xs:attribute name="toServiceID" use="required" type="xs:NMTOKEN"/>
      <xs:attribute name="type" use="required" type="xs:NCName"/>
    </xs:complexType>
  </xs:element>
  <xs:element name="CRUD">
    <xs:complexType>
      <xs:attribute name="instance" use="required" type="xs:string"/>
      <xs:attribute name="logParameter" use="required" type="xs:string"/>
      <xs:attribute name="sessionID" use="required" type="xs:string"/>
      <xs:attribute name="targetProject" use="optional" type="xs:string"/>
    </xs:complexType>
  </xs:element>
  <xs:element name="inputs">
    <xs:complexType>
      <xs:sequence>
        <xs:element maxOccurs="unbounded" minOccurs="0" ref="tgwf:URI"/>
      </xs:sequence>
    </xs:complexType>
  </xs:element>
  <xs:element name="URI">
    <xs:complexType>
      <xs:simpleContent>
        <xs:extension base="xs:anyURI">
          <xs:attribute name="groupId" use="required" type="xs:NMTOKEN"/>
          <xs:attribute name="linkId" use="required" type="xs:NMTOKEN"/>
        </xs:extension>
      </xs:simpleContent>
    </xs:complexType>
  </xs:element>
  <xs:element name="metadatatransformation">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="tgwf:output" maxOccurs="unbounded" minOccurs="0"/>
      </xs:sequence>
    </xs:complexType>
  </xs:element>
  <xs:element name="output">
    <xs:complexType>
      <xs:sequence>
        <xs:element maxOccurs="unbounded" minOccurs="0" ref="tgwf:xslparam"/>
      </xs:sequence>
      <xs:attribute name="fromInputLinkId" use="required" type="xs:NMTOKEN"/>
      <xs:attribute name="outputLinkId" use="required" type="xs:NMTOKEN"/>
      <xs:attribute name="stylesheetURI" use="required" type="xs:anyURI"/>
    </xs:complexType>
  </xs:element>
  <xs:element name="xslparam">
    <xs:complexType mixed="true">
      <xs:simpleContent>
        <xs:extension base="xs:string">
	  <xs:attribute name="name" use="required" type="xs:NCName"/>
	</xs:extension>
      </xs:simpleContent>
    </xs:complexType>
  </xs:element>
  <xs:element name="configparameters">
    <xs:complexType>
      <xs:sequence>
        <xs:element ref="tgwf:activity" maxOccurs="unbounded" minOccurs="0"/>
      </xs:sequence>
    </xs:complexType>
  </xs:element>
  <xs:element name="activity">
    <xs:complexType>
      <xs:sequence>
        <xs:element maxOccurs="unbounded" ref="tgwf:parameter"/>
      </xs:sequence>
      <xs:attribute name="serviceId" use="required" type="xs:integer"/>
    </xs:complexType>
  </xs:element>
  <xs:element name="parameter">
    <xs:complexType mixed="true">
      <xs:sequence>
	<xs:any processContents="lax" minOccurs="0" maxOccurs="unbounded"/> 
      </xs:sequence>
      <xs:attribute name="param" use="required" type="xs:NCName"/>
      <xs:attribute name="paramId" use="required" type="xs:NCName"/>
    </xs:complexType>
  </xs:element>
</xs:schema>
